// Greg Kaiser
//
// CS290 with Prof. Francis
// 4D Tetris
//
// Rotor.C
// Last modified: April 25, 1996
//
// (C) 1996 Board of Trustees University of Illinois

#include <iostream.h>
#include "Rotor.h"

#define ABS(x) ((x>0)?x:-x)
#define IFSHIFT  if(getbutton(LEFTSHIFTKEY)||getbutton(RIGHTSHIFTKEY))
#define PRESS(K,A,b)   if(getbutton(K)){IFSHIFT{A;}else{b;}}

static Matrix id  = {{1.,0.,0.,0.},
		     {0.,1.,0.,0.},
		     {0.,0.,1.,0.},
		     {0.,0.,0.,1.}};
/*Matrix aff = {{1.,0.,0.,0.},
		      {0.,1.,0.,0.},
		      {0.,0.,1.,0.},
		      {0.,0.,0.,1.}};
*/

Rotor::Rotor()
{
  active = 1;
  mouseX = mouseY = 0;
  isMouseDown = isShiftDown =0;

  for (int i = 0; i < 4; i++)
    for (int j = 0; j < 4; j++)
      aff[i][j] = ((i==j) ? 1.0 : 0.0);
}

Rotor::~Rotor()
{}


void Rotor::Rotate()
{
  float dx = (active ? mouseX : 0.0);
  float dy = (active ? mouseY : 0.0);
  if (active) {
    int xt, yt;

    //get the window size
    xt = glutGet(GLUT_WINDOW_WIDTH);
    yt = glutGet(GLUT_WINDOW_HEIGHT);
    //    getsize(&xt,&yt);

    //determine where the mose is in relation to the center or "origin" of the window
    if(dx != 0.0)
      dx -= xt/2;
    if(dy!= 0.0)
      dy -= yt/2;

    dy = -dy;

  }  

  pushmatrix();
  loadmatrix(id); //replaces what's there by the identity
  translate(aff[3][0],aff[3][1],aff[3][2]);
  
  if (active) {
    float torq = .01;
    rot(dx*torq,'y'); rot(-dy*torq, 'x');
    if(isMouseRightDown)
      {
	if(isShiftDown)
	  rot(-10, 'z');
	else
	  rot(-1, 'z');
      }
    
    if(isMouseLeftDown)
      {
	if(isShiftDown)
	  rot(10, 'z');
	else
	  rot(1,'z');
      }
  }

  translate(-aff[3][0],-aff[3][1],-aff[3][2]);
  multmatrix(aff); getmatrix(aff); //x = x+dx  aff<- daff*aff
  popmatrix();
  multmatrix(aff); //replaces rotate turn tilt
}

void Rotor::CurrentMousePosition(int x, int y)
{
  mouseX = x;
  mouseY = y;
}

void Rotor::Activate()
{
  active = 1;
}

void Rotor::Deactivate()
{
  active = 0;
}

void Rotor::MouseLeftDown()
{
  isMouseLeftDown =1;
}

int Rotor::MouseLeftUp()
{
  isMouseLeftDown =0;
  return isMouseRightDown;
}

void Rotor::MouseRightDown()
{
  isMouseRightDown =1;
}

int Rotor::MouseRightUp()
{
  isMouseRightDown =0;
  return isMouseLeftDown;
}

void Rotor::ShiftDown()
{
  isShiftDown = 1;
}

void Rotor::ShiftUp()
{
  isShiftDown =0;
}
